# (c) M_Chabot 2016 ...2021
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# ____________________________________________________________________________
# Description
# This stems from TIG's 'dropverts.rb' where the coding has been set; moving endpoints in the Z axis.
# I ported it to add X and Y axies as a complement. And removed  'To Nearest Object' &  'To Nearest+Z = ?'  'To Z = %'
#
# and packaged the 3 together as a tool set. Naming it, from a user point of view, 'Align Endpoints'.
# added LanguageHandler and french strings.
# ____________________________________________________________________________
=begin
Copyright 2011-2015, TIG (c)
Permission to use, copy, modify, and distribute this software for any
purpose, and currently without fee, is hereby granted, provided that
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied
warranties, including, without limitation, the implied warranties of
merchantability and fitness for a particular purpose.

Menu: 'Plugins' > 'Drop Vertices...' >  changed to 'Align Endpoints' - mc.
'To Nearest Object'  : removed
'To Nearest Below'
'To Nearest Above'
'To Nearest+Z = ?'  : removed
'To Lowest'
'To Highest'
'To Middle'
'To Average'
'To Z = ?'
'To Z = %'   : removed

Usage:
Preselect the edges where you want vertices to 'adjust', choose tool...

'To Nearest Below' means all of the edges' vertices will 'drop' on to
the next 'object' below them, or to Z = 0 if there is nothing below.

'To Nearest Above' means all of the edges' vertices will 'lift' up to
the next 'object' above them, or to Z = 0 if there is nothing above.

'To Lowest' means all of the edges' vertices will 'drop' to match the
Z value of the lowest selected vertex.

'To Highest' means all of the edges' vertices will 'lift' to match the
Z value of the highest selected vertex.

'To Middle' means all of the edges' vertices will 'adjust' to match the
mid Z value between the highest and lowest selected vertices.

'To Average' means all of the edges' vertices will 'adjust' to match the
average Z value of all of the selected vertices; this is not necessarily
the same as 'To Middle' as a disproportionate number of low vertices
in the selection will reduce the average but not affect the mid value.

'To Z = ?' means a dialog asks for the Z value; enter a number to use
current-units e.g. 123 might be 123" or 123mm depending on the model's
current units; to use something other than the current units suffix the
number thus '123mm' to use 123mm when your units might be in 'meters':
the vertices will all adjust to that specified Z value: default Z = 0.

Donations: PayPal.com to info @ revitrev.org

Tig's Versions:
1.0 20110806 First issue.
1.1 20110807 Nearest-Below/-Above, Middle/Average and Z = % options added.
1.2 20110807 Nearest+Z = ? option added.        removed by F3D in 2021
1.3 20110810 Glitch with Lowest/Highest/Middle fixed.
2.0 20150422 Glitches with dropping curves resolved.

MC versions:
1.0 2018 Rough, quick edit to add X & Y alignments
2.0 2021-08 Remake to clean and dry
3.0 2021-08-22 Added HTML, more clean & dry.
3.1 2021-10-25 Fr plugins menu. Ruby styling 'ifs'
3.2 2022-01-02 HTML Styling
=end

module McAEnds
versi = '3.2'

require 'sketchup.rb'
require 'extensions.rb'
require 'langhandler.rb'

 # Constant for language strings swapping...
  LH = LanguageHandler.new('Alend.strings')

  # Load the extension.
  extension_name = LH['AlignEnds']

  path = File.dirname(__FILE__).freeze
  loader = File.join(path, 'Mc-AlignEnds', 'AEndsMenu.rb')
  extension = SketchupExtension.new(extension_name, loader)
  extension.description = (LH['Tools to align endpoints of edges to objects; along X, Y or Z axies.'])
  extension.version = versi
  extension.creator = 'Mario Chabot, (from TIGs Drop Vertices)'
  extension.copyright = '2016, 2021 Format-3D inc.'

  Sketchup.register_extension extension, true
end #module