module McAEnds ## changed the module name, not to interfere in TIGs space.
  require 'sketchup.rb'
  require 'langhandler.rb'
#  require 'Mc-AlignEnds/message.rb'

class AlgnEnds

  def self.activate
	@mod = Sketchup.active_model
	@ents = @mod.active_entities
	@sel = @mod.selection
	@edtr = @mod.edit_transform

	unless @sel[0].is_a? Sketchup::Edge
	  message_file = File.join(__dir__, 'htmlF', 'message.html')
	  text = File.read(message_file)
	  mess = LH['Please, select edges to modify!']
	  text = text.sub('Please, select edges to modify!', "#{mess}")
	  messg_file = File.join(__dir__, "usr_messg.html")
	  File.open(messg_file, "w") { |f| f <<  "#{ text }" }

	  dialog_options = {
		:dialog_title => LH['Align Endpoints'],
		:preferences_key => 'com.example.html-input',
		:min_width  => 400,
		:min_height => 150,
		:max_width  => 420,
		:max_height => 170,
		:style => UI::HtmlDialog::STYLE_DIALOG
	  }
	  dialog = UI::HtmlDialog.new(dialog_options)
	  dialog.set_file(messg_file)

	  dialog.add_action_callback('close_dialog') { |action_context| dialog.close }
	  dialog.center
	  dialog.show_modal
	  return nil
	end

	wrt_Html
  end

  def self.wrt_Html
	path = File.join(__dir__, "/htmlF/")
	@filename = File.join(path, "aEndsInit.html")
	text = File.read(@filename)

	replacements = {
	  'ALING ENDPOINTS along AXIS:' => LH['ALING ENDPOINTS along AXIS:'],
	  'Select an alignment:' => LH['Select an alignment:'],
	  'To Nearest' => LH['To Nearest'],
	  'To Lowest' => LH['To Lowest'],
	  'To Highest' => LH['To Highest'],
	  'To Middle' => LH['To Middle'],
	  'To Average' => LH['To Average'],
	  'To Custom' => LH['To Custom'],
	  'Custom value :' => LH['Custom value :'],
	  }

	toreplace = /#{ replacements.keys.join('|') }/	#list of strings to be replaced
	text = text.gsub(toreplace) { |match| replacements[match] }
	
	text = text.sub('jvals', "#{ @json_str }")

	@filename = File.join(__dir__, "usr_aEnds.html")
	File.open(@filename, "w") { |f| f <<  "#{ text }" }

	show_dialog
  end #wrt_Html

	def self.aends_dialog
	  html_file = File.join(@filename)
	  options = {
	  :top => 150,
	  :left => 800,
	  :width => 420,
	  :height => 320,
	  :dialog_title => LH["Align Endpoints"],
	  :style => UI::HtmlDialog::STYLE_DIALOG
				}
	  dialog = UI::HtmlDialog.new(options)
	  dialog.set_file(html_file)
	  dialog
	end #aends_dialog

	def self.show_dialog
	  @dialog||= aends_dialog

	  @dialog.show
	  @dialog.add_action_callback("getUserInput"){ |action_context, axe, typ, cust|

	  @inp_axe = axe
	  @typ = typ
	  @custm = cust

	  @dialog.close
	  @mod.start_operation ('align, true')
	  cmds
	  }
	end #show_dialog

  def self.cmds
    act = @inp_axe
    move_ends(nil, true, nil, act) if @typ == 'nearmin'
    move_ends(nil, nil, true, act) if @typ == 'nearplus'
    to_lowest(act) if @typ == 'lowest'
    to_highest(act) if @typ == 'highest'
    to_middle(act) if @typ == 'middle'
    to_average(act) if @typ == 'averag'
    to_custom(act) if @typ == 'custom'
  end #cmds

  def self.move_ends(apt = nil, dn = nil, up = nil, act)
	apt = apt.to_f if apt   # to units    - apt : stands for alignment point

	if ! up && ! dn
	  up = true
	  dn = true
	end

	ents = @mod.active_entities

	verts = []                            # local
	@sel.grep(Sketchup::Edge).each do |e|
	  e.explode_curve if e.curve
	  verts << e.vertices
	end #do
	@sel.clear

	unless verts[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	verts.flatten!
	verts.uniq!

	init_vrts = []
	vects = []
	verts.each do |v|
	  init_vrts << v
	  vp = v.position

	  ax = @mod.axes.xaxis if act == 'X'
	  ax = @mod.axes.yaxis if act == 'Y'
	  ax = @mod.axes.zaxis if act == 'Z'

	  if apt
		pt = vp.transform(@edtr.inverse)			### to global
		pt.x = apt if act == 'X'
		pt.y = apt if act == 'Y'
		pt.z = apt if act == 'Z'
		ptf = pt.transform(@edtr)	 		########--- back to local
	  elsif dn
		rayt = @mod.raytest(vp, ax.reverse)
		ptf = rayt ? rayt[0] : vp
	  elsif up
		rayt = @mod.raytest(vp, ax)
	  end #if

	  vects << vp.vector_to(ptf)		########-----------------------<<<<<<<<<
	end #do

	begin
	  @mod.start_operation("move_ends", true)
	  rescue
		@mod.start_operation("move_ends", true)
	end

	  ents.transform_by_vectors(init_vrts, vects) 	########-----------------------<<<<<<<<<
	  return init_vrts  	# returns array of vertices processed
	  @mod.commit_operation
  end #move_ends

  def self.to_lowest(act)  # act : sets action in the concerned axis
	pts = []
	@sel.grep(Sketchup::Edge).each do |e|
	  pt = e.line[0].transform(@edtr.inverse)
	  pts << pt
	  pt = e.end.position.transform(@edtr.inverse)
	  pts << pt
	end #do

	unless pts[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	pts.flatten!
	pts.uniq!

	if act == 'X'
	  apt = pts[0].x
	  pts.each { |pt| 
	    apt = pt.x if pt.x < apt }
	elsif act == 'Y'
	  apt = pts[0].y
	  pts.each { |pt| apt = pt.y if pt.y < apt }
	elsif act == 'Z'
	  apt = pts[0].z
	  pts.each { |pt| apt = pt.z if pt.z < apt }
	end #if
	move_ends(apt, nil, nil, act)
  end #to_lowest

  def self.to_highest(act)
	pts = []
	@sel.grep(Sketchup::Edge).each do |e|
	  pt = e.line[0].transform(@edtr.inverse)
	  pts << pt
	  pt = e.end.position.transform(@edtr.inverse)
	  pts << pt
	end #do

	unless pts[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	pts.flatten!
	pts.uniq!

	if act == 'X'
	  apt = pts[0].x
	  pts.each { |pt| apt = pt.x if pt.x > apt }
	elsif act == 'Y'
	  apt = pts[0].y
	  pts.each { |pt| apt = pt.y if pt.y > apt }
	elsif act == 'Z'
	  apt = pts[0].z
	  pts.each { |pt| apt = pt.z if pt.z > apt }
	end #if

	move_ends(apt, nil, nil, act)
  end #to_highest

  def self.to_middle(act)
	pts = []
	@sel.grep(Sketchup::Edge).each do |e|
	  pt = e.line[0].transform(@edtr.inverse)
	  pts << pt
	  pt = e.end.position.transform(@edtr.inverse)
	  pts << pt
	end #do

	unless pts[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	pts.flatten!
	pts.uniq!

	if act == 'X'
	  apt1 = apt2 = pts[0].x
	  pts.each do|pt|
		apt1 = pt.x if pt.x > apt1
		apt2 = pt.x if pt.x < apt2
	  end #do
	elsif act == 'Y'
	  apt1 = apt2 = pts[0].y
	  pts.each do|pt|
		apt1 = pt.y if pt.y > apt1
		apt2 = pt.y if pt.y < apt2
	  end #do
	elsif act == 'Z'
	  apt1 = apt2 = pts[0].z
	  pts.each do|pt|
		apt1 = pt.z if pt.z > apt1
		apt2 = pt.z if pt.z < apt2
	  end #do
	end #if

	apt = (apt1 - ((apt1 - apt2) /2.0)).to_s+'"'
	move_ends(apt, nil, nil, act)
  end #to_middle

  def self.to_average(act)
	pts = []
	@sel.grep(Sketchup::Edge).each do |e|
	  pt = e.line[0].transform(@edtr.inverse)
	  pts << pt
	  pt = e.end.position.transform(@edtr.inverse)
	  pts << pt
	end #do

	unless pts[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	pts.flatten!
	pts.uniq!

	apt1 = 0.0
	if act == 'X'
	  pts.each { |pt| apt1  =  apt1 + pt.x }
	elsif act == 'Y'
	  pts.each { |pt| apt1  =  apt1 + pt.y }
	elsif act == 'Z'
	  pts.each { |pt| apt1  =  apt1 + pt.z }
	end #if

	apt  =  (apt1 / (pts.length.to_f)).to_s+'"'
	move_ends(apt, nil, nil, act)
  end #to_average

  def self.to_custom(act)
	unless @sel[0]
	  UI.messagebox(LH["Pre-Select Edges!"])
	  return nil
	end

	apt = @custm
	apt = "0" unless apt

	move_ends(apt, nil, nil, act)
  end #by_dialog

end #class

end#module
